#ifndef __LIBOPCHDA__H__
#define __LIBOPCHDA__H__

#include <windows.h>
#include <stdio.h>
#include <objbase.h>
#include <olectl.h>
#include <comcat.h>
#include "opcda.h"
#include "opchda.h"

// Defines the maximum number of values per item that can be returned in a single call.
#define OPCHDA_MAX_VALUES 10000

#ifndef LIBOPCHDA_EXPORT
#define LIBOPCHDA_EXPORT __declspec(dllimport)
#endif
#define LIBOPCHDA_INTERFACE extern "C" LIBOPCHDA_EXPORT

struct OpcHdaValue{
	DWORD			quality;
	LONGLONG		timestamp;
	VARIANT			value;
};

struct OpcHdaAttribute{
	DWORD			attrId;
	LONGLONG		timestamp;
	VARIANT			value;
};

LIBOPCHDA_INTERFACE void OpcHdaInitialize();

LIBOPCHDA_INTERFACE void OpcHdaStart();
LIBOPCHDA_INTERFACE void OpcHdaStartThreaded();

LIBOPCHDA_INTERFACE void OpcHdaRegister();
LIBOPCHDA_INTERFACE void OpcHdaUnregister();

LIBOPCHDA_INTERFACE void OpcHdaRegisterValuesHandler(OpcHdaValue *(*GetValuesForItem)(void *userObject,LONGLONG start,LONGLONG end,OpcHdaValue *(*allocator)(int count,void *object),void *object));
LIBOPCHDA_INTERFACE void OpcHdaRegisterAttributesHandler(OpcHdaAttribute *(*GetAttributesForItem)(void *userObject,LONGLONG start,LONGLONG end,OpcHdaAttribute *(*allocator)(int count,void *object),void *object));

LIBOPCHDA_INTERFACE void *OpcHdaCreateItem(wchar_t *name,void *userObject);
LIBOPCHDA_INTERFACE void OpcHdaDeleteItem(wchar_t *name);

LIBOPCHDA_INTERFACE void OpcHdaCreateAttribute(DWORD attrId,VARTYPE vtDataType,wchar_t *name,wchar_t *description);

LIBOPCHDA_INTERFACE void OpcHdaSetProcessedFixedMode(bool fixed);

#endif
